//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "musicbar0.h"
#include <stdlib.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
enum WaveColor { PEN, LEVEL, BACKGROUND };
class MusicWave
{ private:
     int mHeight, mWidth, mPt, prev, mX, mY, dx;
     float mLevel;
     //float *pt;
     //static int test;
     bool toLeft, reset, mShowLevel;
     TColor mPenColor, mLevelColor, mBackColor ;
  public:
     MusicWave(int width=50, int height=50)
       { mWidth=width; mHeight=height; mPt=0; dx=3;
         mLevel=0.0;
         toLeft=true; mShowLevel=false;
         mPenColor=clYellow; mLevelColor=clLime; mBackColor=clBlack;
         //head=tail=0;
         //if ( mPt>1 ) pt=new float[mPt];
       }
     //~MusicWave() { if ( pt!=NULL ) delete [] pt; }
     //int   nextPoint(int no) { return((no+1)%mPt); }
     void  setColor(WaveColor wcType, TColor color);
     void  setDirection(bool lft) { toLeft=lft; }
     void  setSize(TCanvas *canvas, int width, int height);
     void  showLevel(float level) { mLevel=level; mShowLevel=true; }
     void  hideLevel() { mShowLevel=false; }
     void  showWave(TCanvas *canvas, int x, int y, int value);
};
void MusicWave::setColor(WaveColor wcType, TColor color)
{ switch( wcType )
    { case PEN        : mPenColor=color;   break;
      case LEVEL      : mLevelColor=color; break;
      case BACKGROUND : mBackColor=color;  break;
    }
}
void MusicWave::setSize(TCanvas *canvas, int width, int height)
{ canvas->Brush->Color=clBlack;
  canvas->Pen->Color=clBlack;
  //canvas->Rectangle(x, y-mHeight, x+mWidth, y+1);
  mWidth=width; mHeight=height;
}
void MusicWave::showWave(TCanvas *canvas, int x, int y, int value)
{ canvas->Brush->Color=clBlack;
  canvas->Pen->Color=clBlack;
  if ( mPt==0 ) // first data coming
    { prev=value;
      mPt=1;
      canvas->Rectangle(x, y-mHeight, x+mWidth, y+1);
      if ( mShowLevel )
        { canvas->Pen->Color=clLime;
          canvas->MoveTo(x, y-mLevel);
          canvas->LineTo( x+mWidth, y-mLevel);
        }
    }
  else
    { if ( toLeft )
        { canvas->CopyRect(TRect(x, y-mHeight, x+mWidth-dx, y+1), canvas,
                           TRect(x+dx, y-mHeight, x+mWidth, y+1) );
          canvas->Rectangle(x+mWidth-dx, y-mHeight, x+mWidth, y+1);
          if ( mShowLevel )
            { canvas->Pen->Color=clLime;
              canvas->MoveTo(x+mWidth-dx-1, y-mLevel);
              canvas->LineTo(x+mWidth-1,    y-mLevel);
            }
          canvas->Pen->Color=clYellow;
          canvas->MoveTo(x+mWidth-dx-1, y-prev);
          canvas->LineTo(x+mWidth-1,    y-value);
        }
      else  // moving to right
        { canvas->CopyRect(TRect(x+dx-1, y-mHeight, x+mWidth, y+1), canvas,
                           TRect(x-1, y-mHeight, x+mWidth-dx, y+1) );
          canvas->Rectangle(x-1, y-mHeight, x+dx, y+1);
          if ( mShowLevel )
            { canvas->Pen->Color=clLime;
              canvas->MoveTo(x+dx, y-mLevel);
              canvas->LineTo(x,    y-mLevel);
            }
          canvas->Pen->Color=clYellow;
          canvas->MoveTo(x+dx, y-prev);
          canvas->LineTo(x,    y-value);
        }
      prev=value;
    }
}

class MusicBar
{ private:
     int mHeight, mWidth, mLevel, down, top;
     //static int test;
     static TColor mColor[4];
  public:
     MusicBar(int width=5, int height=50) { mWidth=width; mHeight=height; mLevel=0; down=1; }
     void setSize(int width, int height) { mWidth=width; mHeight=height;}
     void showBar(TCanvas *canvas, int px, int py, int value);
};
//int MusicBar::test=10;
// for initialization, given array all the value;
TColor MusicBar::mColor[]={ clLime, clYellow, clFuchsia, clRed };
/* below codes seem fine but error occur.
TColor MusicBar::mColor[1]=clGreen;
TColor MusicBar::mColor[2]=clRed;
TColor MusicBar::mColor[3]=clRed;
*/
void MusicBar::showBar(TCanvas *canvas, int px, int py, int value)
{ int k, index;

  if ( value>=mLevel )
    { mLevel=value;
      down=0;
      top = 1;
    }
  else
    { top++;
      if ( top>4 ) down =2; //down++;  // falling fast
      mLevel-=down;
      if ( mLevel<0 ) mLevel=0;
    }
  canvas->Brush->Color=clBlack;
  canvas->Pen->Color=clBlack;
  canvas->Rectangle(px, py, px+mWidth, py-mHeight);
  if ( value<=0 && mLevel==0 )
    { canvas->Pen->Color = clWhite;
      canvas->MoveTo(px, py);
      canvas->LineTo(px+mWidth, py);
    }
  else
    { for (k=0; k<value; k+=2)
         { canvas->Pen->Color = mColor[(k<<2)/mHeight];
           canvas->MoveTo(px, py-k);
           canvas->LineTo(px+mWidth, py-k);
         }
    }
  canvas->Pen->Color=clWhite;
  canvas->MoveTo(px, py-mLevel);
  canvas->LineTo(px+mWidth, py-mLevel);
}

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
#define BarNo 20
MusicBar mbar[BarNo];
MusicWave mwave(200, 50);

void __fastcall TForm1::Button1Click(TObject *Sender)
{ int w=5, h=40;

  for (int k=0; k<BarNo; ++k)
     { mbar[k].setSize(w, h);
       mbar[k].showBar(Form1->Canvas, 80+(w+1)*k, 150, random(h) );
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if ( Timer1->Enabled )
    Button2->Caption="Timer Start";
  else Button2->Caption="Timer Stop";
  Timer1->Enabled= ! Timer1->Enabled; // switch the timer state.
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  Button1Click(this);
  Button4Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  mwave.showWave(Form1->Canvas, 250, 150, 20);
  mwave.showLevel(10);
  //mwave.setSize(Form1->Canvas, 50,50);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  mwave.showWave(Form1->Canvas, 250, 150, random(49) );

}
//---------------------------------------------------------------------------


void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  mwave.setDirection(CheckBox1->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{ int dx=10, dy=20, x=0, ds=4;
  for (int s=0; s<256; s+=ds)
     { Form1->Canvas->Pen->Color = RGB(s,255-s,0);
       Form1->Canvas->MoveTo(dx+x, dy);
       Form1->Canvas->LineTo(dx+x, dy+20);
       x++;
     }
  /*
  int r=,g=255;
  for (int s=0; s<256; s+=ds)
     { if ( s<128 )
         { Form1->Canvas->Pen->Color = RGB(r, g, 0);
           Form1->Canvas->MoveTo(dx+x, dy);
           Form1->Canvas->LineTo(dx+x, dy+20);
           g -= ds;
           x++;
         }
       else
         { Form1->Canvas->Pen->Color = RGB(s,255-s,0);
           Form1->Canvas->MoveTo(dx+x, dy);
           Form1->Canvas->LineTo(dx+x, dy+20);
           r += s;
           x++;
         }
     }
  */
}
//---------------------------------------------------------------------------

